From e115da1bb17c3b049c05aa4711b29c4a69b27d45 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 729/1001] Convert the stats widget


---

diff --git a/hubs/widgets/stats/__init__.py b/hubs/widgets/stats/__init__.py
new file mode 100644
index 0000000..1ffe664
--- /dev/null
+++ b/hubs/widgets/stats/__init__.py
@@ -0,0 +1,66 @@
+from __future__ import unicode_literals
+
+import flask
+
+from hubs.utils import commas
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+
+class Stats(Widget):
+
+    name = "stats"
+    position = "right"
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/stats.html"
+    chrome = panel()
+
+    def get_context(self, instance, *args, **kwargs):
+        get_stats = GetStats(instance)
+        return get_stats()
+
+
+class GetStats(CachedFunction):
+
+    def execute(self):
+        hub = self.instance.hub
+        owners = [u.username for u in hub.owners]
+        members = [u.username for u in hub.members]
+        subscribers = [u.username for u in hub.subscribers]
+        stargazers = [u.username for u in hub.stargazers]
+
+        return dict(
+            owners=owners,
+            members=members,
+            subscribers=subscribers,
+            stargazers=stargazers,
+
+            owners_text=commas(len(owners)),
+            members_text=commas(len(members)),
+            subscribers_text=commas(len(subscribers)),
+            stargazers_text=commas(len(stargazers)),
+
+            hub_leave_url=flask.url_for('hub_leave', hub=hub.name),
+            hub_join_url=flask.url_for('hub_join', hub=hub.name),
+            hub_unstar_url=flask.url_for('hub_unstar', hub=hub.name),
+            hub_star_url=flask.url_for('hub_star', hub=hub.name),
+            hub_subscribe_url=flask.url_for('hub_subscribe', hub=hub.name),
+            hub_unsubscribe_url=flask.url_for(
+                'hub_unsubscribe', hub=hub.name),
+        )
+
+    def should_invalidate(self, message):
+        if not message['topic'].endswith('hubs.hub.update'):
+            return False
+        if message['msg']['hub']['name'] == self.instance.hub.name:
+            return True
+
+        # TODO -- also check for FAS group changes??  are we doing that?
+
+        return False

